// ===========================================================================
// ==                                                                       ==
// ==                                                                       ==
// ===========================================================================
#ifndef _MONSTER_H_
#define _MONSTER_H_

#include "Actors/Actor.h"

/**
   Monster class. It's a actor which can be mortal for player.
*/
class Monster : public Actor
{
public:
  /** */
  Monster(int x, int y, int z = 0);
  /** */
  bool isMortal() const;
protected:
  bool _isMortal;
};
// ==================== INLINE SECTION =======================================
inline 
Monster::Monster(int x, int y, int z) : 
  Actor(x,y,z),
  _isMortal(false)
{
}
// ===========================================================================
inline bool
Monster::isMortal() const
{
  return _isMortal;
}
#endif
