// ===========================================================================
// ==               Player class : Definition                               ==
// ==               Atchoum et X. Pinguin 9 April 2000                      ==
// ===========================================================================
#ifndef _PLAYER_H_
#define _PLAYER_H_

#include "Graphism/Sprite.h"
#include "Actors/Actor.h"

class DataRoom;

/**
   Player class : The actor representation of the player.
 */
class Player : public Actor
{
public:
  /** */
  Player(DataRoom& room, int posx, int posy, int energy);
  /** */
  Player(int x, int y, int energy);
  /** */
  virtual bool mustRedraw() const;
  /** */
  virtual bool setAction(int Action);
  /** */
  virtual bool setAction();
  /** */
  void doAction();
  /** */
  int getEnergy() const;
  /** */
  void decEnergy();
  /** */
  void setEnergy(int ener);
  /** */
  virtual Actor* clone(DataRoom& room, int x, int y, int z=0) const;
private:
  /** */
  void move();
  //
  int _dx, _dy, _nact;
  // 
  int _energy;
}; // End class Player
// ============= INLINE SECTION ==============================================
inline int
Player::getEnergy() const
{
  return _energy;
}
// ===========================================================================
inline void
Player::decEnergy()
{
  _energy--;
}
// ===========================================================================
inline void 
Player::setEnergy(int ener)
{
  _energy = ener;
}
#endif
