// ===========================================================================
// ==                     Class DataObject : Definition                     ==
// ==                   Atchoum & X.Pinguin 5 Mars 2000                     ==
// ===========================================================================
#ifndef _DATAOBJECT_H
#define _DATAOBJECT_H

/**
   Cette classe reprsente les donnes "jeux" d'un lment de la scne.
   Par exemple, si cette object peut-tre dtruit, si il est mortel au
   simple contact, etc...
*/
class DataObject
{
public:
  /** 
      Constructeur. On donne la position initiale de l'acteur sur la scne.
  */
  DataObject(int id, bool obstacle=false, bool mortal=false) :
    _id(id),
    _isMortal(mortal),
    _isObstacle(obstacle)
  {
  }
  /**
     Destructeur.
  */
  ~DataObject() {}
  /**
     Renvoie un boolen pour savoir si cet objet est mortel ou non
     au simple contact. */
  bool isMortal() const;
  /**
     Renvoie un boolen pour dire si un monstre ou un personnage peut
     traverser cet objet sans se heurter  lui. */
  bool isObstacle() const;
  /**
   */
  int getId() const;
private:
  bool _isMortal;
  bool _isObstacle;
  int  _id;
};
// ======================== INLINE SECTION =================================
inline bool
DataObject::isMortal() const
{
  return _isMortal;
}
// ==========================================================================
inline bool
DataObject::isObstacle() const
{
  return _isObstacle;
}
// ===========================================================================
inline int
DataObject::getId() const
{
  return _id;
}
// 
#endif
