// =============================================================================
// ==                    Class StaticRoom : Implementation                    ==
// ==                    Atchoum & X. Pinguin : 3 Mars 2000                   ==
// =============================================================================

#include "StaticRoom.h"

/*#ifdef DEBUG
# include <assert.h>
# define ASSERTACCESS \
           assert( x >=0); \
           assert( x<_lx); \
           assert( y >=0); \
           assert( y<_ly); \
           assert( z>=0 ); \
           assert( z<_lz)
#else
#define ASSERTACCESS
#endif*/

StaticRoom::StaticRoom( int lx, int ly, int lz) :
  _lx(lx), _ly(ly), _lz(lz),
  _staticObjs(lx*ly*lz,(DataObject*)NULL)
{  
}
// ===========================================================================
StaticRoom::~StaticRoom()
{
}
// ===========================================================================
void
StaticRoom::insert(DataObject& obj, int x, int y, int z)
{
  //  ASSERTACCESS;

  _staticObjs[x+y*_lx+z*_lx*_ly] = &obj;
}
// ===========================================================================
bool
StaticRoom::remove(int x, int y, int z)
{
  //  ASSERTACCESS;

  DataObject* ptObj = _staticObjs[x+y*_lx+z*_lx*_ly];

  _staticObjs[x+y*_lx+z*_lx*_ly] = NULL;

  return (ptObj!=NULL);
}
// ===========================================================================
bool
StaticRoom::remove(const DataObject& obj)
{
  StaticRoom::iterator iter;
  for (iter = begin(); iter != end(); iter++)
  {
    if ((*iter)==&obj)
    {
      (*iter) = NULL;
      break;
    }
  }
  return ((*iter)!=NULL);
}
