// ===========================================================================
// ==           Class Font : Definition                                     ==
// ==           Atchoum & X. Pinguin 6 Avril 2000                           ==
// ===========================================================================

#include <stdlib.h>

#include "Graphism/Font.h"
#include "Graphism/Sprite.h"
#include "Graphism/Screen.h"

Font::Font(const std::string& fontName) : 
  _cptRef(new int(1)),
  _ptrSpr(NULL)
{
	  std::string dirName("Graphisme/");
	  std::string name = dirName+fontName;
  Image fontImg(name.c_str());
  fontImg.setTransparentPixel(0,0);
  _ptrSpr = new Sprite(fontImg, 16, 6);
}
// ===========================================================================
Font::Font(const std::string& fontName,
	   const std::string& dirName  ) : 
  _cptRef(new int(1)),
  _ptrSpr(NULL)
{
	  std::string name = dirName+fontName;
  Image fontImg(name.c_str());
  fontImg.setTransparentPixel(0,0);
  _ptrSpr = new Sprite(fontImg, 16, 6);
}
// ===========================================================================
Font::Font(const Font& font) : 
  _cptRef(font._cptRef),
  _ptrSpr(font._ptrSpr)
{
  (*_cptRef)++;
}
// ===========================================================================
Font::~Font()
{
  (*_cptRef)--;
  if (0 == (*_cptRef))
  {
    delete _cptRef;
    delete _ptrSpr;
  }
}
// ===========================================================================
const Font&
Font::operator= (const Font& font)
{
  if (this != &font)
  {
    (*_cptRef)--;
    if (0 == (*_cptRef))
    {
      delete _cptRef;
      delete _ptrSpr;
    }
    _cptRef = font._cptRef;
    (*_cptRef)++;
    _ptrSpr = font._ptrSpr;
  }
  return (*this);
}
// ===========================================================================

