// ========================================================================
// ==             Class Screen : Definition                              ==
// ==              Atchoum & X Pinguin  6 Fevrier 2000                   ==
// ========================================================================
#ifndef _SCREEN_HH_
#define _SCREEN_HH_

#include <SDL.h>

class Text;
class Sprite;
class Image;

class Screen
{
 public:
    /** initialisation automatique de l'cran en utilisant le meilleur mode
	Automatic initialisation of the screen using the best mode. */
  Screen(bool fullscreen=true);

  /** initialisation  la main
      hand initialisation. */
  Screen(unsigned int h, unsigned int w, unsigned int bpp, bool fullscreen=true);
  /** Destructeur.
      Destructor. */
  ~Screen();
  /** Accesseur.
      Accessor methode.
  */
  unsigned int readHeight() const;
  unsigned int readWidth() const;

  /** Operation d'ecriture sur l'ecrant
      On ecrit sur un buffer
      Puis on blit sur la memoire video. */
  void directWrite(unsigned int x, unsigned int y, 
		   Uint8 red, Uint8 green, Uint8 blue);
  /** Blitter le rsultat  l'cran */
  void blit();
  /** */
  void clear();
  /** */
  SDL_Surface* getScreen();
 private:
  void verbose() const;
  SDL_Surface* _screen;
  SDL_Surface* _buffer;
  bool _fullscreen;
};
// ===========================================================================
inline SDL_Surface*
Screen::getScreen()
{
  return _buffer;
}
#endif
