// ========================================================================
// ==                    Class Text : Definition                         ==
// ==                    Atchoum & X Pinguin 26 Mars 2000                ==
// ========================================================================
#ifndef _LETTER_H_
#define _LETTER_H_

#include <string>

#include "Graphism/Sprite.h"
#include "Graphism/Font.h"

class Screen;

/**
   Classe encapsulant l'image d'une lettre qu'on pourra afficher ensuite 
   l'cran.
*/
class Text
{
public:
  /** Constructeur. 

      @param a La phrase  afficher  l'cran.
  */
  Text(const std::string& a,
       int x=0, int y=0);
  /**
   */
  ~Text();
  /** Retourne le numro de frame correspondant  la premire lettre  afficher. */
  int beginFrame() const;
  /** Retourne le numro de frame suivant. Si ce numro est gal  -1 alors
      on est arriv  la fin du texte. */
  int nextFrame() const;
  /**
     Change la fonte du texte  afficher  l'cran.
   */  
  void changeFont(const Font& font);
  /**
     Get the font. 
  */
  const Font& getFont() const;
  /**
     Get the position where we must print the text.
  */
  void getPosition(int& x, int& y) const;
  /**
     Set q new position for the text.
  */
  void setNewPos(int x, int y);
 private:
  mutable int   _pos;
  std::string   _text;
  Font*          _font;
  int           _x,_y;
  friend Screen& operator<<( Screen& scr, const Text& aText);
};
// ================ INLINE SECTION ==========================================
inline int
Text::beginFrame() const
{
  _pos = 0;
  return int(_text[0]-' ');
}
// ==========================================================================
inline int
Text::nextFrame() const
{
  _pos++;
  if (_pos < _text.length() )
    return int(_text[_pos]-' ');
  return -1;
}
// ===========================================================================
inline void
Text::changeFont(const Font& font)
{
  delete _font;
  _font = new Font(font);
}
// ===========================================================================
inline const Font&
Text::getFont() const
{
  return *_font;
}
// ===========================================================================
inline  void 
Text::getPosition(int& x, int& y) const
{
  x = _x; y = _y;
}
// ===========================================================================
inline void 
Text::setNewPos(int x, int y)
{
  _x = x; _y = y;
}
#endif
