// ===========================================================================
// ==                                                                       ==
// ==                                                                       ==
// ===========================================================================
#ifndef _IABASE_H
#define _IABASE_H

class DataActor;
class DataRoom;

/**
   This class is a abstraction of the action chooser of a actor in the game.
   The action chooser can be a python scrip ( IAPython ) or C++ class ( RockIA )
   or a interactive class ( IAPlayer ) which, for instance, read the
   keyboard or the mouse.
 */
class IABase
{
public:
  /** */
  IABase(const DataRoom& room, const DataActor& actor);
  /** */
  virtual ~IABase();
  /** */
  virtual int chooseAction() = 0;
protected:
  const DataRoom&  _room;
  const DataActor& _actor;
};
// ================= INLINE SECTION ==========================================
inline 
IABase::IABase(const DataRoom& room, const DataActor& actor) :
  _room(room),
  _actor(actor)
{
}
#endif
