// ===========================================================================
// ==          Object class definition                                      ==
// ==          Atchoum & X. Pinguin 24 April 2000                           ==
// ===========================================================================
#ifndef _OBJECT_H
#define _OBJECT_H

#include "Data/DataObject.h"
class RenderObject;

/**
   It's the representation of a object in the game ( Wall, and so... )
 */
class Object
{
public:
  /** */
  Object(int id, bool obstacle=false, bool mortal = false);
  /** */
  Object(const Object& obj);
  /** */
  virtual ~Object();
  /** */
  DataObject& getData();
  /** */
  RenderObject& getRender();
  /** */
  virtual Object* clone(int x, int y) const =0;
protected:
  //
  DataObject _data;
  //
  RenderObject* _render;
};
// ===========================================================================
inline
Object::Object(int id, bool obstacle, bool mortal) :
  _data(id, obstacle, mortal),
  _render(0)
{
}
// ===========================================================================
inline DataObject&
Object::getData()
{
  return _data;
}
// ===========================================================================
inline RenderObject&
Object::getRender()
{
  return *_render;
}
// ===========================================================================
inline
Object::~Object()
{
}
#endif
