// ===========================================================================
// ==                                                                       ==
// ==                                                                       ==
// ===========================================================================
#ifndef _RENDERROOM_H
#define _RENDERROOM_H

#include "Util/RoomContainer.h"

class RenderObject;
class RenderActor;
class Screen;

class RenderRoom
{
public:
  /** */
  RenderRoom(int lx, int ly, int lz=0);
  /** */
  ~RenderRoom();
  /** */
  Screen& render(Screen& scr);
  /** */
  void addObject(RenderObject& obj, int x, int y, int z=0);
  /** */
  bool removeObject(int x, int y, int z=0);
  /** */
  void addActor(RenderActor& actor, int x, int y, int z=0);
  /** */
  bool removeActor(int x, int y, int z = 0);
private:
  //
  RoomContainer<RenderObject*> _staticRendering;
  //
  RoomContainer<RenderActor*> _dynamicRendering;
};
// ========== INLINE SECTION ==============================================
inline Screen&
operator<<(Screen& scr, RenderRoom& room)
{
  return room.render(scr);
}
#endif
